<?php
/*--------------------------------------------------------------
   customer_registration_date_migration.php 2022-09-01
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2022 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

/**
 * setting customers_date_added for main admin to installation date of the shop
 */
$shopInstallationQuery = 'SELECT installation_date FROM `version_history` WHERE is_full_version = 1';
$shopInstallationDate  = $this->query($shopInstallationQuery)[0]['installation_date'];
$shopAdminUpdateQuery  = sprintf('UPDATE `customers` SET `customers_date_added`="%s" WHERE customers_id = 1 AND `customers_date_added`="1000-01-01 00:00:00"', $shopInstallationDate);
$t_success &= $this->query($shopAdminUpdateQuery, true);

/**
 * updating customers_date_added to their first order if the date is 1000-01-01...
 */
$setToFirstOrderUpdateQuery = <<<SQL
REPLACE INTO customers (
                        `customers_date_added`, `customers_id`, `customers_cid`, `customers_vat_id`,
                        `customers_vat_id_status`, `member_flag`, `delete_user`, `account_type`,
                        `customers_is_favorite`, `password_request_key`, `payment_unallowed`,
                        `shipping_unallowed`, `refferers_id`, `customers_warning`, `customers_status`,
                        `customers_fax`, `customers_telephone`, `customers_newsletter`,
                        `customers_gender`, `customers_firstname`, `customers_lastname`, `customers_company`,
                        `customers_is_tradesperson`, `customers_dob`, `customers_email_address`, `customers_default_address_id`,
                        `customers_newsletter_mode`, `customers_password`
                        )
SELECT
       MIN(`o`.`date_purchased`) as 'first_order', `c`.`customers_id`, `c`.`customers_cid`, `c`.`customers_vat_id`,
       `c`.`customers_vat_id_status`, `c`.`member_flag`, `c`.`delete_user`, `c`.`account_type`,
       `c`.`customers_is_favorite`, `c`.`password_request_key`, `c`.`payment_unallowed`,
       `c`.`shipping_unallowed`, `c`.`refferers_id`, `c`.`customers_warning`, `c`.`customers_status`,
       `c`.`customers_fax`, `c`.`customers_telephone`, `c`.`customers_newsletter`,
       `c`.`customers_gender`, `c`.`customers_firstname`, `c`.`customers_lastname`, `c`.`customers_company`,
       `c`.`customers_is_tradesperson`, `c`.`customers_dob`, `c`.`customers_email_address`, `c`.`customers_default_address_id`,
       `c`.`customers_newsletter_mode`, `c`.`customers_password`
FROM `customers` `c`
INNER JOIN `orders` `o` ON `o`.`customers_id`=`c`.`customers_id`
WHERE `c`.`customers_date_added` = '1000-01-01 00:00:00'
GROUP BY `c`.`customers_id`, `c`.`customers_cid`, `c`.`customers_vat_id`,
       `c`.`customers_vat_id_status`, `c`.`member_flag`, `c`.`delete_user`, `c`.`account_type`,
       `c`.`customers_is_favorite`, `c`.`password_request_key`, `c`.`payment_unallowed`,
       `c`.`shipping_unallowed`, `c`.`refferers_id`, `c`.`customers_warning`, `c`.`customers_status`,
       `c`.`customers_fax`, `c`.`customers_telephone`, `c`.`customers_newsletter`, `c`.`customers_status`,
       `c`.`customers_gender`, `c`.`customers_firstname`, `c`.`customers_lastname`, `c`.`customers_company`,
       `c`.`customers_is_tradesperson`, `c`.`customers_dob`, `c`.`customers_email_address`, `c`.`customers_default_address_id`,
       `c`.`customers_newsletter_mode`, `c`.`customers_password`
SQL;

$t_success &= $this->query($setToFirstOrderUpdateQuery, true);